<template>
  <q-dialog v-model="computedShow">
    <q-card style="min-width: 50vw; max-width: 80vw; min-height: 50vh">
      <q-bar class="bg-primary text-white"
        ><span class="nunito">Settings</span>
        <q-space />
      </q-bar>
      <q-card-section>
        <q-splitter v-model="splitterModel" style="height: 100%">
          <template v-slot:before>
            <q-tabs v-model="computedTab" vertical class="text-teal">
              <q-tab name="serial" icon="mdi-connection" label="Serial" />
              <q-tab name="plot" icon="mdi-chart-bell-curve-cumulative" label="Plot" />
            </q-tabs>
          </template>

          <template v-slot:after>
            <q-tab-panels
              v-model="computedTab"
              animated
              swipeable
              vertical
              transition-prev="jump-up"
              transition-next="jump-up"
            >
              <q-tab-panel name="serial">
                <SerialSettings />
              </q-tab-panel>
              <q-tab-panel name="plot">
                <PlotSettings />
              </q-tab-panel>
            </q-tab-panels>
          </template>
        </q-splitter>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script lang="ts">
import { defineComponent, computed, ref } from 'vue';
import SerialSettings from 'components/settings/SerialSettings.vue';
import PlotSettings from 'components/settings/PlotSettings.vue'

export default defineComponent({
  components: {
    SerialSettings,
    PlotSettings
  },
  props: {
    show: {
      type: Boolean,
      default: () => false,
    },
    tab: {
      type: String,
      default: () => 'serial',
    },
  },
  setup(props, { emit }) {
    const computedShow = computed({
      get: () => {
        return props.show;
      },
      set: (value: boolean) => {
        emit('update:show', value);
      },
    });

    const computedTab = computed({
      get: () => {
        return props.tab;
      },
      set: (value: string) => {
        emit('update:tab', value);
      },
    });

    return {
      computedShow,
      computedTab,
      splitterModel: ref(10),
    };
  },
});
</script>
